// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef ACTUATOR_HH
#define ACTUATOR_HH

#include <cstddef>
#include <stdint.h>

class actuator
{

public:

    uint32_t pwdata_old;
    bool pwrite_old;
    bool penable_old;
    bool psel_old;
    uint32_t paddr_old;
    bool presetn_old;
    bool pclk_old;
    struct actuator_iostruct{
        bool * pclk;
        bool * presetn;
        uint32_t * paddr;
        bool * psel;
        bool * penable;
        bool * pwrite;
        uint32_t * pwdata;
        bool * pready;
        uint32_t * prdata;
        bool * actuator_open;
        bool * actuator_close;
        uint16_t * actuator_threshold;

        actuator_iostruct():
            pclk(nullptr),
            presetn(nullptr),
            paddr(nullptr),
            psel(nullptr),
            penable(nullptr),
            pwrite(nullptr),
            pwdata(nullptr),
            pready(nullptr),
            prdata(nullptr),
            actuator_open(nullptr),
            actuator_close(nullptr),
            actuator_threshold(nullptr)
        {}

        actuator_iostruct( bool * pclk_1, bool * presetn_1, uint32_t * paddr_1,
             bool * psel_1, bool * penable_1, bool * pwrite_1, uint32_t * pwdata_1,
             bool * pready_1, uint32_t * prdata_1, bool * actuator_open_0, bool
             * actuator_close_0, uint16_t * actuator_threshold_0 ):
            pclk(pclk_1),
            presetn(presetn_1),
            paddr(paddr_1),
            psel(psel_1),
            penable(penable_1),
            pwrite(pwrite_1),
            pwdata(pwdata_1),
            pready(pready_1),
            prdata(prdata_1),
            actuator_open(actuator_open_0),
            actuator_close(actuator_close_0),
            actuator_threshold(actuator_threshold_0)
        {}

        ~actuator_iostruct()
        {}

        bool operator == (const actuator_iostruct & other) const
        {
            if (pclk != other.pclk) return false;
            if (presetn != other.presetn) return false;
            if (paddr != other.paddr) return false;
            if (psel != other.psel) return false;
            if (penable != other.penable) return false;
            if (pwrite != other.pwrite) return false;
            if (pwdata != other.pwdata) return false;
            if (pready != other.pready) return false;
            if (prdata != other.prdata) return false;
            if (actuator_open != other.actuator_open) return false;
            if (actuator_close != other.actuator_close) return false;
            if (actuator_threshold != other.actuator_threshold) return false;
            return true;
        }
    };
    actuator_iostruct hif_a2t_data;
    bool actuator_open_reg;
    bool actuator_close_reg;
    uint16_t actuator_threshold_reg;
    actuator();


    ~actuator();


    bool actuator_open_reg_new;
    bool actuator_close_reg_new;
    uint16_t actuator_threshold_reg_new;
    bool process_in_queue;
    bool flag_initial_process_executed;
    bool flag_process_executed;
    bool flag_pos_pclk;

    void initial_process();


    void process();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();


private:

    actuator( const actuator & );
    const actuator& operator= ( const actuator & );


};


#endif

